' "<$fbc>" -dll "<$file>" -x ..\ConsolePlugin.dll
#include "\Basic4GL\Basic4GLMacros.bi"

const PLUG_DESC = "for Basic4GL"
const PLUG_MAJOR = 0
const PLUG_MINOR = 1

  
type CONSOLELIB
  pDll                 as any ptr
  pConsoleCreate       as function () as integer
  pConsoleDestroy      as sub ()
  pConsoleCls          as sub ()
  pConsoleSetColors    as sub (f as integer,b as integer)
  pConsoleShowCursor   as sub (f as integer)
  pConsoleSetCursorPos as function (x as integer,y as integer) as integer
  pConsoleSetTitle     as sub (t as zstring ptr)
  pConsoleGetKey       as function () as zstring ptr
  pConsoleRead         as function () as zstring ptr
  pConsoleWrite        as sub (t as zstring ptr)
  pConsoleWriteR       as sub (t as zstring ptr)
end type
dim shared as string     errormsg
dim shared as CONSOLELIB wrapper
dim shared as integer    InUse

extern "C"


DPF(ConsoleCreate) '       as function () as integer
  if InUse<>0 then
    wrapper.pConsoleDestroy()
  end if
  InUse=wrapper.pConsoleCreate()
  SIR(InUse)
end sub
DPF(ConsoleDestroy) '      as sub ()
  if InUse<>0 then
    wrapper.pConsoleDestroy()
    InUse=0
  end if
end sub

DPF(ConsoleCls) '      as sub ()
  if InUse<>0 then
    wrapper.pConsoleCls()
  end if
end sub

DPF(ConsoleSetColors)  '   as sub (f as integer,b as integer)
  if InUse<>0 then
    wrapper.pConsoleSetColors(GIP(2),GIP(1))
  end if 
end sub
DPF(ConsoleShowCursor) '   as sub (f as integer)
  if InUse<>0 then
    wrapper.pConsoleShowCursor(GIP(1))
  end if
end sub
DPF(ConsoleSetCursorPos) ' as function (x as integer,y as integer) as integer
  if InUse<>0 then
    SIR(wrapper.pConsoleSetCursorPos(GIP(2),GIP(1)))
  end if
end sub
DPF(ConsoleSetTitle) '     as sub (t as zstring ptr)
  if InUse<>0 then
    wrapper.pConsoleSetTitle(GSP(1))
  end if
end sub
DPF(ConsoleGetKey) '       as function () as zstring ptr
  if InUse<>0 then
   SSR(wrapper.pConsoleGetKey())
  end if
end sub
DPF(ConsoleRead) '         as function () as zstring ptr
  if InUse<>0 then
    SSR(wrapper.pConsoleRead())
  end if
end sub
DPF(ConsoleWrite) '        as sub (t as zstring ptr)
  if InUse<>0 then
    wrapper.pConsoleWrite(GSP(1))
  end if
end sub
DPF(ConsoleWriteR) '       as sub (t as zstring ptr)
  if InUse<>0 then
    wrapper.pConsoleWriteR(GSP(1))
  end if
end sub

' ##########
' # Plugin #
' ##########

function Load (THIS_PLUGIN, _
               THIS_REGISTRY, _
               blnIsExe as byte) as integer

  wrapper.pDll=dylibload("TinyConsole.dll")
  if wrapper.pDll=0 then
    errormsg="fatal error: can't load TinyConsole.dll !"
    return 0
  end if

  with wrapper
    .pConsoleCreate         = dylibsymbol(.pDll,"_ConsoleCreate")
    .pConsoleDestroy        = dylibsymbol(.pDll,"_ConsoleDestroy")
    .pConsoleCls            = dylibsymbol(.pDll,"_ConsoleCls")
    .pConsoleSetColors      = dylibsymbol(.pDll,"_ConsoleSetColors")
    .pConsoleShowCursor     = dylibsymbol(.pDll,"_ConsoleShowCursor")
    .pConsoleSetCursorPos   = dylibsymbol(.pDll,"_ConsoleSetCursorPos")
    .pConsoleSetTitle       = dylibsymbol(.pDll,"_ConsoleSetTitle")
    .pConsoleGetKey         = dylibsymbol(.pDll,"_ConsoleGetKey")
    .pConsoleRead           = dylibsymbol(.pDll,"_ConsoleRead")
    .pConsoleWrite          = dylibsymbol(.pDll,"_ConsoleWrite")
    .pConsoleWriteR         = dylibsymbol(.pDll,"_ConsoleWriteR")
  end with

  RIF(ConsoleCreate)
  RVF(ConsoleDestroy)
  RVF(ConsoleCls):TimeShare
  RVF(ConsoleSetColors):AIP:AIP
  RVF(ConsoleShowCursor):AIP
  RIF(ConsoleSetCursorPos):AIP:AIP
  RVF(ConsoleSetTitle):ASP
  RSF(ConsoleGetKey)
  RSF(ConsoleRead):TimeShare
  RVF(ConsoleWrite):ASP
  RVF(ConsoleWriteR):ASP

  return 1
end function

sub Unload (THIS_PLUGIN)
  if wrapper.pDll then
    if InUse<>0 then
      wrapper.pConsoleDestroy()
    end if
    dylibfree wrapper.pDll
    wrapper.pDll=0
  end if
end sub

function Start (THIS_PLUGIN) as integer
  return 1
end function

sub      Ends (THIS_PLUGIN)

end sub

sub      Pause (THIS_PLUGIN)

end sub

sub      Resumed (THIS_PLUGIN)

end sub

sub      DelayedResume (THIS_PLUGIN)

end sub

sub      GetError  (THIS_PLUGIN,ErrMsg as zstring ptr)
  if len(errormsg) then
    for i as integer=0 to len(errormsg)-1
      ErrMsg[i]=errormsg[i]
    next
  end if
end sub

sub      ProcessMessages(THIS_PLUGIN)

end sub

' Query function
function Basic4GL_Query  alias "Basic4GL_Query" (byval details as string, _
                                                 byref major   as integer, _
                                                 byref minor   as integer) as integer export
  dim as string detailSrc = PLUG_DESC
  for i as integer = 0 to len(detailSrc)
    details[i] = detailSrc[i]
  next
  major = PLUG_MAJOR
  minor = PLUG_MINOR
  return BASIC4GL_DLL_VERSION
end function

dim shared as IDLL_Basic4GL_Plugin ptr Plugin
' Main initialisation function.
' Here we will construct and return our plugin object
function Basic4GL_Init  alias "Basic4GL_Init" () as IDLL_Basic4GL_Plugin ptr ptr export
  Plugin=new IDLL_Basic4GL_Plugin
  ' Construct and return our plugin object
  Plugin->Load           =@Load
  Plugin->Unload         =@Unload
  Plugin->Start          =@Start
  Plugin->Ends           =@Ends
  Plugin->Pause          =@Pause
  Plugin->Resumed        =@Resumed
  Plugin->DelayedResume  =@DelayedResume
  Plugin->GetError       =@GetError
  Plugin->ProcessMessages=@ProcessMessages

  return @Plugin
end function

end extern
